<template>
  <ContentWrapper>
    <div class="content-heading">
      <div>
        {{user.id == 0 ? 'Registrar novo usuário' : 'Atualizar usuário - '+user.name}}
        <ol class="breadcrumb breadcrumb px-0 pb-0">
          <li class="breadcrumb-item">
            <a href="/users" @click.prevent="$router.push({path:'/users'})">Usuários</a>
          </li>
          <li class="breadcrumb-item active">{{user.id == 0 ? 'Registrar' : 'Atualizar'}}</li>
        </ol>
      </div>
    </div>
    <div class="card">
      <!-- <div class="card-header"> -->
      <!-- <div
          class="card-title"
        >{{user.id == 0 ? 'Registrar novo usuário' : 'Atualizar usuário - '+user.name}}</div>
        <div class="text-sm"></div>
      </div>-->
      <div :class="'card-body'+(process.list ? ' whirl duo':'')">
        <!-- CADASTRO-->
        <form
          :class="(process.form ? ' whirl duo':'')"
          @submit.prevent="validateBeforeSubmit('user')"
          data-vv-scope="user"
        >
          <div class="bg-gray-lighter px-3 py-2 my-3">Informações pessoais</div>
          <div class="card-body">
            <!-- NOME -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Nome completo*</label>
              <div class="col-md-9">
                <input
                  v-model="user.name"
                  v-validate="'required'"
                  :class="{'form-control':true, 'is-invalid': errors.has('user.name')}"
                  type="text"
                  name="name"
                >
                <span v-show="errors.has('user.name')" class="invalid-feedback">Informe seu nome</span>
              </div>
            </div>

            <!-- CPF -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">CPF*</label>
              <div class="col-md-9">
                <masked-input
                  type="text"
                  class="form-control"
                  placeholder="CPF"
                  v-model="user.cpf"
                  :mask="mask.cpf"
                />
                <span v-show="invalid.cpf" style="color: red;font-size: 80%;">Informe um CPF válido</span>
              </div>
            </div>

            <!-- EMAIL -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">E-mail*</label>
              <div class="col-md-9">
                <input
                  v-model="user.email"
                  v-validate="'required|email'"
                  :class="{'form-control':true, 'is-invalid': errors.has('user.email')}"
                  type="email"
                  name="email"
                >
                <span
                  v-show="errors.has('user.email')"
                  class="invalid-feedback"
                >Informe um e-mail válido</span>
              </div>
            </div>
          </div>

          <!-- ENDEREÇO -->
          <div class="bg-gray-lighter px-3 py-2 my-3">Informações endereço</div>
          <div :class="'card-body'+(process.cep ? ' whirl duo' : '')">
            <!-- CEP -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">CEP*</label>
              <div class="col-md-9">
                <masked-input
                  v-model="user.address_zipcode"
                  v-validate="'required|min:9|max:9'"
                  :class="{'form-control':true, 'is-invalid': errors.has('user.address_zipcode')}"
                  type="text"
                  class="form-control"
                  placeholder="CEP"
                  :mask="mask.address_zipcode"
                  name="address_zipcode"
                  @input="consultCep()"
                />
                <span
                  v-show="errors.has('user.address_zipcode')"
                  class="invalid-feedback"
                >Informe um CEP válido</span>
              </div>
            </div>

            <!-- RUA -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Endereço*/Número</label>
              <div class="col-md-9">
                <input
                  v-model="user.address_street"
                  v-validate="'required'"
                  :class="{'form-control':true, 'is-invalid': errors.has('user.address_street')}"
                  type="text"
                  placeholder="Rua/Complemento"
                  name="address_street"
                >
                <span
                  v-show="errors.has('user.address_street')"
                  class="invalid-feedback"
                >Informe sua rua</span>
              </div>
            </div>

            <!-- BAIRRO -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Bairro*</label>
              <div class="col-md-9">
                <input
                  :disabled="cepFinish"
                  v-model="user.address_neighborhood"
                  v-validate="'required'"
                  :class="{'form-control':true, 'is-invalid': errors.has('user.address_neighborhood')}"
                  type="text"
                  placeholder="Bairro/setor"
                  name="address_neighborhood"
                >
                <span
                  v-show="errors.has('user.address_neighborhood')"
                  class="invalid-feedback"
                >Informe seu bairro/setor</span>
              </div>
            </div>

            <!-- CIDADE -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Cidade*</label>
              <div class="col-md-9">
                <input
                  :disabled="cepFinish"
                  v-model="user.address_city"
                  v-validate="'required'"
                  :class="{'form-control':true, 'is-invalid': errors.has('user.address_city')}"
                  type="text"
                  placeholder="Cidade"
                  name="address_city"
                >
                <span
                  v-show="errors.has('user.address_city')"
                  class="invalid-feedback"
                >Informe sua cidade</span>
              </div>
            </div>

            <!-- ESTADO -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">UF*</label>
              <div class="col-md-9">
                <select
                  :disabled="cepFinish"
                  class="custom-select-d custom-select-sm"
                  v-model="user.address_state"
                  v-validate="'required'"
                  :class="{'form-control':true, 'is-invalid': errors.has('user.address_state')}"
                >
                  <option v-for="uf in ufs" :key="uf" :value="uf">{{uf}}</option>
                </select>
                <br>
                <span v-show="invalid.uf" style="color: red;font-size: 80%;">Informe seu estado</span>
              </div>
            </div>
          </div>
          <!-- INFORMACOES BANCARIAS -->
          <div class="bg-gray-lighter px-3 py-2 my-3">Informações bancárias</div>
          <div class="card-body">
            <!-- BANCO -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Banco*</label>
              <div class="col-md-9">
                <select
                  class="custom-select-d custom-select-sm"
                  v-model="user.bank.bank_id"
                  v-validate="'required|is_not:0'"
                  :class="{'form-control':true, 'is-invalid': errors.has('user.bank.bank_id')}"
                >
                  <option
                    v-for="bank in banks"
                    :key="bank.bank_id"
                    :value="bank.bank_id"
                  >{{bank.bank_name+' ('+bank.bank_number+')'}}</option>
                </select>
                <br>
                <span v-show="invalid.bank" style="color: red;font-size: 80%;">Selecione o seu banco</span>
              </div>
            </div>

            <!-- NUMERO DA CONTA / DIGITO -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Conta*/dígito</label>
              <div class="col-md-9">
                <b-input-group>
                  <b-form-input
                    v-model="user.bank.account"
                    v-validate="'required'"
                    :class="{'form-control':true, 'is-invalid': errors.has('user.bank.account')}"
                    type="text"
                    placeholder="Número da conta"
                    name="bank.account"
                  ></b-form-input>
                  <b-form-input
                    v-model="user.bank.account_digit"
                    :class="{'form-control':true}"
                    type="text"
                    placeholder="Dígito da conta"
                    name="account_digit"
                  ></b-form-input>
                </b-input-group>
                <span
                  v-show="errors.has('user.bank.account')"
                  class="invalid-feedback"
                >Informe o número da conta</span>
              </div>
            </div>

            <!-- NUMERO DA AGENCIA / DIGITO -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Agencia*/dígito</label>
              <div class="col-md-9">
                <b-input-group>
                  <b-form-input
                    v-model="user.bank.agency"
                    v-validate="'required'"
                    :class="{'form-control':true, 'is-invalid': errors.has('user.bank.agency')}"
                    type="text"
                    placeholder="Agencia da conta"
                    name="bank.agency"
                  ></b-form-input>
                  <b-form-input
                    v-model="user.bank.agency_digit"
                    :class="{'form-control':true}"
                    type="text"
                    placeholder="Dígito da agência"
                    name="agency_digit"
                  ></b-form-input>
                </b-input-group>
                <span
                  v-show="errors.has('user.bank.agency')"
                  class="invalid-feedback"
                >Informe a agência da conta</span>
              </div>
            </div>

            <fieldset v-if="user.id != 0">
              <div class="form-group row mb-2">
                <div class="col-md-12">
                  <p class="mt-3">Selecione os perfis para este usuário</p>
                  <multiselect
                    v-model="user.roles"
                    :options="roles"
                    :multiple="true"
                    :close-on-select="false"
                    :clear-on-select="false"
                    :hide-selected="true"
                    :preserve-search="true"
                    placeholder="Insira aqui"
                    label="name"
                    track-by="name"
                    tag-placeholder="Adicionar perfil"
                    :taggable="true"
                    @tag="addTag"
                  />
                  <span v-show="invalid.roles" style="color: red;font-size: 80%;">Selecione o perfil</span>
                </div>
              </div>
              <div style="color:red">* Campos requeridos</div>
            </fieldset>
          </div>
          <div class="text-right">
            <b-button
              class="mr-1 mb-1"
              type="submit"
              :variant="'success'"
            >{{ user.id == 0 ? 'REGISTRAR' : 'ATUALIZAR'}}</b-button>
          </div>
        </form>
      </div>
    </div>
  </ContentWrapper>
</template>
<script>
import Datatable from "@/components/Tables/Datatable";
import MaskedInput from "vue-text-mask";
import Multiselect from "vue-multiselect";

import UserService from "@/domain/user/UserService";
import BankService from "@/domain/bank/BankService";
import RoleService from "@/domain/role/RoleService";
import User from "@/domain/user/User";
import Bank from "@/domain/bank/Bank";
import Role from "@/domain/role/Role";
import Uf from "@/domain/uf/Uf";

import NotificationProvider from "@/provider/NotificationProvider";
import swal from "sweetalert2";

export default {
  name: "user-form",
  components: {
    Datatable,
    MaskedInput,
    Multiselect
  },
  created() {
    if (this.$route.params.id) {
      this.process.list = true;
      // buscando usuario para editar
      console.log("Buscando usuario id " + this.$route.params.id);
      this.userService
        .get(this.$route.params.id)
        .then(user => {
          this.user = user;
          this.process.list = false;
        })
        .catch(err => {
          console.log(JSON.stringify(err));
          this.notificationProvider.error(
            "Falha na comunicação",
            "Não foi possível buscar o usuário"
          );
        });
    }
    this.bankService.list(999, 1).then(response => {
      this.banks = response;
    });
    this.roleService
      .list(999, 1)
      .then(response => (this.roles = response))
      .catch(err => {
        console.log(JSON.stringify(err));
        this.notificationProvider.error(
          "Erro na consulta",
          "Erro ao consultar os perfis de usuário"
        );
      });
  },
  data() {
    return {
      invalid: {
        cpf: false,
        roles: false,
        uf: false,
        bank: false
      },
      ufs: Uf.ufs,
      modalForm: false,
      user: new User(),
      bank: new Bank(),
      banks: [],
      users: [],
      roles: [],
      bankService: new BankService(),
      userService: new UserService(),
      roleService: new RoleService(),
      notificationProvider: new NotificationProvider(this.$notify),
      dtOptions: {
        paging: true, // Table pagination
        ordering: true, // Column ordering
        info: true, // Bottom left status text
        responsive: true,
        // Text translation options
        // Note the required keywords between underscores (e.g _MENU_)
        oLanguage: {
          sSearch: '<em class="fa fa-search"></em>',
          sLengthMenu: "_MENU_ registros por página",
          info: "Página _PAGE_ de _PAGES_",
          zeroRecords: "Nada encontrado",
          infoEmpty: "Nenhum registro",
          infoFiltered: "(Filtrado de _MAX_ itens)",
          oPaginate: {
            sNext: '<em class="fa fa-caret-right"></em>',
            sPrevious: '<em class="fa fa-caret-left"></em>'
          }
        },
        // Datatable key setup
        keys: false
      },
      mask: {
        cpf: [
          /\d/,
          /\d/,
          /\d/,
          ".",
          /\d/,
          /\d/,
          /\d/,
          ".",
          /\d/,
          /\d/,
          /\d/,
          "-",
          /\d/,
          /\d/
        ],
        address_zipcode: [/\d/, /\d/, /\d/, /\d/, /\d/, "-", /\d/, /\d/, /\d/]
      },
      cepFinish: false,
      process: {
        form: false,
        list: false,
        cep: false,
        bank: false
      }
    };
  },
  methods: {
    validateBeforeSubmit(scope) {
      this.$validator.validateAll(scope).then(result => {
        // validações
        var cancel = false;
        if (this.user.id != 0 && this.user.roles.length == 0) {
          this.invalid.roles = true;
          cancel = true;
        } else {
          this.invalid.roles = false;
        }
        if (this.user.address_state == "") {
          this.invalid.uf = true;
          cancel = true;
        } else {
          this.invalid.uf = false;
        }
        if (this.user.bank.bank_id == 0) {
          this.invalid.bank = true;
          cancel = true;
        } else {
          this.invalid.bank = false;
        }
        var cpf = this.user.cpf;
        cpf = cpf.replace("-", "");
        cpf = cpf.replace(/_/g, "");
        cpf = cpf.replace(".", "");
        cpf = cpf.replace(".", "");
        if (cpf.length < 11) {
          this.invalid.cpf = true;
          cancel = true;
        } else {
          this.invalid.cpf = false;
        }

        if (result && !cancel) {
          this.process.form = true;
          if (this.user.id == 0) {
            // CADASTRAR
            this.userService
              .create(this.user)
              .then(response => {
                console.log("usuario criado");
                this.notificationProvider.success(
                  "Usuário registrado!",
                  this.user.name + " registrado com sucesso"
                );
                this.user = new User();
                this.users.push(response);
                this.process.form = false;
                this.modalForm = false;
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                if (
                  err.response != undefined &&
                  err.response.data != undefined &&
                  err.response.data.exception ==
                    "Prettus\\Validator\\Exceptions\\ValidatorException"
                ) {
                  for (var key in err.response.data.message) {
                    this.notificationProvider.error(
                      "Verificar " + key,
                      err.response.data.message[key][0]
                    );
                  }
                } else {
                  console.log(JSON.stringify(err));
                  this.notificationProvider.error(
                    "Falha ao registrar",
                    "Houve uma falha ao registrar o usuário"
                  );
                }
                this.process.form = false;
              });
          } else {
            // EDITAR
            this.userService
              .update(this.user.id, this.user)
              .then(response => {
                for (var i = 0; i < this.users.length; i++) {
                  if (this.users[i].id == response.id) {
                    this.users[i] = new User(
                      response.id,
                      response.name,
                      response.cpf,
                      response.email,
                      "",
                      response.address_street,
                      response.address_neighborhood,
                      response.address_city,
                      response.address_state,
                      response.address_zipcode,
                      response.signed_contract,
                      response.bank,
                      response.roles
                    );
                  }
                }
                console.log("usuario atualizado");
                this.notificationProvider.success(
                  "Usuário atualizado!",
                  this.user.name + " registrado com sucesso"
                );
                this.user = new User();
                this.process.form = false;
                this.modalForm = false;
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                if (
                  err.response &&
                  err.response.data &&
                  err.response.data.exception &&
                  err.response.data.exception ==
                    "Prettus\\Validator\\Exceptions\\ValidatorException"
                ) {
                  // alguma validação deu errado
                  for (var key in err.response.data.message) {
                    this.notificationProvider.error(
                      "Verificar " + key,
                      err.response.data.message[key][0]
                    );
                  }
                } else {
                  console.log(JSON.stringify(err));
                  this.notificationProvider.error(
                    "Falha ao registrar",
                    "Houve uma falha ao registrar o usuário"
                  );
                }
                this.process.form = false;
              });
          }
        }
      });
    },
    remove(user) {
      swal({
        title: "Deletar " + user.id + "#" + user.name + "? ",
        text: "Não será possível recuperar!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: "Sim, deletar!"
      }).then(result => {
        if (result.value) {
          this.userService
            .delete(user.id)
            .then(response => {
              this.users.forEach((el, index) => {
                if (user.id == el.id) {
                  this.users.splice(index, 1);
                }
              });
              this.notificationProvider.success(
                "Deletado",
                "Usuário " + user.name + " deletado com sucesso!"
              );
            })
            .catch(err => {
              if (
                err.response &&
                err.response.data &&
                err.response.data.message &&
                err.response.data.message.indexOf(
                  "Integrity constraint violation"
                )
              ) {
                // erro de vinculo no banco
                this.notificationProvider.error(
                  "Não é possível remover",
                  "Existem registros vinculados a este registro"
                );
              } else {
                console.log(JSON.stringify(err));
                this.notificationProvider.error(
                  "Falha ao remover",
                  "Não foi possível remover este registro"
                );
              }
            });
        }
      });
    },
    add() {
      this.user = new User();
      this.modalForm = false;
      this.modalForm = true;
    },
    edit(us) {
      this.user = new User(
        us.id,
        us.name,
        us.cpf,
        us.email,
        us.password,
        us.address_street,
        us.address_neighborhood,
        us.address_city,
        us.address_state,
        us.address_zipcode,
        us.signed_contract,
        us.bank,
        us.roles
      );
      this.modalForm = false;
      this.modalForm = true;
    },
    consultCep() {
      let cep = this.user.address_zipcode;
      cep = cep.replace("-", "");
      cep = cep.replace("_", "");
      if (cep.length == 8) {
        this.process.cep = true;
        Uf.consultCep(this.user.address_zipcode)
          .then(response => {
            this.user.address_street = response.logradouro;
            this.user.address_neighborhood = response.bairro;
            this.user.address_city = response.localidade;
            this.user.address_state = response.uf;
            this.process.cep = false;
            this.cepFinish = true;
          })
          .catch(err => {
            console.log(JSON.stringify(err));
            this.process.cep = false;
            this.cepFinish = false;
          });
      }
    },
    addTag(newTag) {
      this.user.roles.push({
        name: newTag,
        language: "Some language"
      });
    }
  }
};
</script>
<style src="vue-multiselect/dist/vue-multiselect.min.css">
</style>